.386
.model flat, stdcall
option casemap:none




include \masm32\include\gdi32.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\windows.inc

includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib

WinMain PROTO :DWORD, :DWORD, :DWORD, :DWORD
.const


.data

  AppName db "Win32asm_class", 0
  ClassName db "executer_window", 0

.data?

  Xwindow dd ?
  Ywindow dd ?
  Xwindowdiv2 dd ?
  Ywindowdiv2 dd ?
  hInstance HINSTANCE ?
  hArrPlan dd ?
  rect RECT <?, ?, ?, ?>

.code

  start:

    invoke GetSystemMetrics, SM_CXSCREEN
    mov Xwindow, eax
    shr eax, 1
    mov Xwindowdiv2, eax
    invoke GetSystemMetrics, SM_CYSCREEN
    mov Ywindow, eax
    shr eax, 1
    mov Ywindowdiv2, eax

    invoke GetModuleHandle, NULL
    mov hInstance, eax
    invoke WinMain, hInstance, NULL, NULL, SW_SHOWDEFAULT
    invoke ExitProcess, eax

    WinMain PROC hInst:HINSTANCE, hPrevInst:HINSTANCE, CmdLine:LPSTR, CmdShow:DWORD
      LOCAL wc:WNDCLASS
      LOCAL Msg:MSG
      LOCAL hWnd:HWND

      mov wc.style, CS_HREDRAW or CS_VREDRAW
      mov wc.lpfnWndProc, OFFSET WndProcfullscreen
      mov wc.cbClsExtra, NULL
      mov wc.cbWndExtra, NULL
      push hInst
      pop wc.hInstance
      mov wc.hIcon, NULL
      invoke LoadCursor, NULL, IDC_ARROW
      mov wc.hCursor, eax
      invoke GetStockObject, BLACK_BRUSH
      mov hArrPlan, eax
      mov wc.hbrBackground, eax
      mov wc.lpszMenuName, NULL
      mov wc.lpszClassName, OFFSET ClassName
      invoke RegisterClass, ADDR wc
      invoke CreateWindowEx, NULL, OFFSET ClassName, OFFSET AppName, WS_POPUP, 0, 0, Xwindow, Ywindow, NULL, NULL, hInst, NULL
      mov hWnd, eax
      invoke ShowWindow, hWnd, SW_SHOWDEFAULT
      invoke UpdateWindow, hWnd
      .WHILE TRUE
        invoke InvalidateRect, hWnd, NULL, FALSE
        invoke GetMessage, ADDR Msg, NULL, NULL, NULL
        .BREAK .IF !eax
        invoke TranslateMessage, ADDR Msg
        invoke DispatchMessage, ADDR Msg
      .ENDW
      mov eax, Msg.wParam
      ret
    WinMain ENDP

WndProcfullscreen PROC uses ebx hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
      LOCAL hDC:HANDLE
      LOCAL hMemDC:HANDLE
      LOCAL hBmp:HANDLE
      LOCAL ps:PAINTSTRUCT

      .IF uMsg == WM_CREATE
  mov rect.left, 0
        mov rect.top, 0
        push Xwindow
        pop rect.right
        push Ywindow
        pop rect.bottom
  invoke GlobalAlloc, GMEM_MOVEABLE or GMEM_ZEROINIT,  hInstance
       mov hInstance, eax
        invoke GlobalLock, hInstance
        mov hInstance, eax
        invoke ShowCursor, FALSE
      .ELSEIF uMsg == WM_DESTROY
        invoke ShowCursor, TRUE
 
        invoke PostQuitMessage, NULL
      .ELSEIF uMsg == WM_KEYDOWN
        .IF wParam == VK_ESCAPE
          invoke SendMessage, hWnd, WM_DESTROY, NULL, NULL
      

        .ENDIF
      .ELSEIF uMsg == WM_PAINT
        invoke BeginPaint, hWnd, ADDR ps
        mov hDC, eax
        invoke CreateCompatibleDC, hDC
        mov hMemDC, eax
        invoke CreateCompatibleBitmap, hDC, Xwindow, Ywindow
        mov hBmp, eax
        invoke SelectObject, hMemDC, hBmp
        invoke FillRect, hMemDC, OFFSET rect, hArrPlan
        xor ecx, ecx
  invoke BitBlt, hDC, 0, 0, Xwindow,Ywindow, hMemDC, 0, 0, SRCCOPY
        invoke DeleteObject, hBmp
        invoke DeleteDC, hMemDC
        invoke EndPaint, hWnd, ADDR ps
      .ELSE
        invoke DefWindowProc, hWnd, uMsg, wParam, lParam
        ret
      .ENDIF
      xor eax, eax
      ret
WndProcfullscreen ENDP
  end start  